<template>
  <v-text-field
    v-bind="$attrs"
    :label="$t('title', { requiredFlag: required ? '*' : '' })"
    :rules="rules"
    v-on="$listeners"
  />
</template>

<script>
  import { required, minLength, maxLength } from '@/lib/validators'

  export default {
    name: 'TitleField',
    props: {
      required: {
        type: Boolean,
        required: false,
        default: false,
      },
      minLength: {
        type: Number,
        required: false,
        default: 3,
      },
      maxLength: {
        type: Number,
        required: false,
        default: 64,
      },
    },
    data () {
      return {
        defaultRules: [minLength(this.minLength), maxLength(this.maxLength)],
      }
    },
    computed: {
      rules () {
        return this.required
          ? [...this.defaultRules, required]
          : this.defaultRules
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          title: 'Título{requiredFlag}',
        },
        'en-US': {
          title: 'Title{requiredFlag}',
        },
      },
    },
  }
</script>
